<script>
import { clientLogin, sendMsg,captchaImage,getValidateCaptcha } from '@/api/newLogin.js'
export default {
  data() {
    return {
      phone: '', phoneMsg: '',
      countdown: 60,
      startCountdownFlag: false,
      showCaptcha: false,
      imgCode: '',
      captchaImg: '',
      uuid: '',
      isSendingCode: false,
    }
  },
  computed: {
    canGetCode() {
      return !this.isSendingCode && this.countdown === 60
    },
    // canBind() {
    //   return this.code && this.code.length === 6 && !this.isBinding
    // }
  },
  onLoad(options) {
    if (options.phone) {
      this.phone = options.phone
      this.getCode()
    }

  },
  methods: {
     //图形验证码提交
    submitImgCode() {
      if (!this.imgCode) {
        uni.showToast({
          title: '请输入验证码',
          icon: 'none'
        })
        return 
      }
      
      getValidateCaptcha({ uuid: this.uuid, code: this.imgCode,phone:this.phone }).then(res => {
        if (res.data.code == 200) {
          this.showCaptcha = false
          this.getCode()
        }else{
            this.imgCode=''
            uni.showToast({
              title: res.data.message,
              icon: 'none'
            })
          }
      })


    },
    validatePhone(phone) {
      const reg = /^1[3-9]\d{9}$/
      return reg.test(phone)
    },
    //重新获取验证码
		agginGetCode() {
      this.getCaptcha()
      this.imgCode=''
      this.showCaptcha = true

		},
    //获取图形验证码
    getCaptcha() {
      captchaImage().then(res => {
        if (this.showCaptcha) {
          this.captchaImg = "data:image/gif;base64," + res.data.img;
          this.uuid = res.data.uuid;
        }
      })
    },
    //获取手机验证码
    getCode() {
      if (this.isSendingCode || this.countdown < 60) return

      this.isSendingCode = true
      sendMsg({ phone: this.phone }).then(res => {
        console.log(res)

        uni.showToast({
          title: '验证码已发送',
        })

        this.startCountdown()
        this.isSendingCode = false

      })


    },
    startCountdown() {
      this.startCountdownFlag = true
      this.countdown = 60
      this.timer = setInterval(() => {
        this.countdown--
        if (this.countdown <= 0) {
          clearInterval(this.timer)
          this.startCountdownFlag = false
          this.countdown = 60
          this.timer = null
        }
      }, 1000)
    },
    // 满6位自动校验
    autoCheckCode(val) {
      // 输入刚好6位时自动提交
      if (val.length === 4) {

        clientLogin({
          //openId: uni.getStorageSync('wx_copenid'),
          userType: '2',
          phone: this.phone,
          codeSwitch: 'true',//是否开启验证码登录 true-是 false-否
          phoneMsg: this.phoneMsg
        }).then(res => {
          if (res.data.code == 200) {
            // uni.showToast({
            //   title: '登录成功',
            //   icon: 'success'
            // })
            uni.setStorageSync('wx_phone', this.phone)
            this.back()
          }else{
            uni.showToast({
              title: res.data.msg,
              icon: 'none'
            })
          }
        })
      }

    },
    back() {
      let pages = getCurrentPages();
      if (pages.length >= 2) {
        let prevPage = pages[pages.length - 3];
        let prevRoute = prevPage.route;
        if (prevRoute && prevRoute !== 'pages/index/index') {
          if (prevRoute.startsWith('pages/')) {
            uni.switchTab({
              url: '/' + prevRoute
            })
          } else {
            uni.navigateBack({
              delta: 1,
              fail: () => {
                uni.switchTab({
                  url: '/pages/index/index'
                })
              }
            })
          }
        } else {
          uni.switchTab({
            url: '/pages/index/index'
          })
        }
      } else {
        uni.switchTab({
          url: '/pages/index/index'
        })
      }
    },
  },
  beforeDestroy() {
    if (this.timer) {
      clearInterval(this.timer)
      this.timer = null
    }
  }
}
</script>

<template>
  <view class="sett-box">
    <view class="greeting-area">
      <view class="bubble-box">
        <view class="bubble-text">请输入验证码</view>
        <view class="sendTag">验证码已发送至：{{ phone }}</view>
      </view>
    </view>
    <view class="greeting-area1"></view>
    <view style="display: flex;justify-content: center;padding: 0 64rpx;">
      <view class="input-box">
        <u-input v-model="phoneMsg" type="number" border="none" maxlength="6" placeholder="请输入手机验证码"
          placeholder-style="font-weight: 400;font-size: 30rpx;color: #C9CDD4;" class="input-item code-input"
          @input="autoCheckCode"></u-input>
        <view class="code-btn" :class="{ disabled: !canGetCode }">
            <text v-if="startCountdownFlag">{{ countdown }}s</text>
            <text @click="agginGetCode">重新获取</text>
          
        </view>
      </view>
    </view>


     <!-- 图形验证码弹窗 -->
    <u-popup :show="showCaptcha" mode="center" border-radius="12">
      <view class="captcha-box">
        <view class="captcha-title">
          <view>请输入下方图形验证码</view>
          <u-icon custom-style="position: relative;left:90rpx ;" name="close" color="#C9CDD4" size="20"
            @click="showCaptcha = false"></u-icon>
        </view>
        <view style="padding: 0 48rpx;margin-top: 48rpx;">
          <view style="display: flex;align-items: center;justify-content: space-between;height: 106rpx;border-bottom: 1rpx solid #E7E7E7;">

            <!-- 验证码输入框，唤起全字符键盘 -->
            <u-input v-model="imgCode" placeholder="请输入图形验证码" :focus="showCaptcha" type="text" maxlength="4"
              border="none" placeholder-style="font-weight: 400;font-size: 30rpx;color: #C9CDD4;"></u-input>
            <!-- 图形验证码图片，点击刷新 -->
             <!-- <img :src="captchaImg" @click="getCode" class="register-code-img"/> -->
            <image :src="captchaImg" @click="refreshCaptcha" class="captcha-img"></image>
          </view>
          <view class="text" @click="getCaptcha">看不清？ 换一张</view>
          <u-button class="submitImgCode" @click="submitImgCode" block>确定</u-button>

        </view>
      </view>
    </u-popup>





  </view>
</template>

<style scoped lang="scss">
.captcha-box {
  width: 622rpx;
  background: #FFFFFF;
  border-radius: 32rpx 32rpx 32rpx 32rpx;

  .captcha-title {
    display: flex;
    justify-content: center;
    align-items: center;
    font-weight: 500;
    font-size: 32rpx;
    color: #333333;
    text-align: center;
    padding: 32rpx 0;
    border-bottom: 1rpx solid #E7E7E7;

  }

  .captcha-img {
    //width: 100%;
    width: 146rpx;
    height: 60rpx;
  }

  .submitImgCode {
    width: 526rpx;
    height: 88rpx;
    background: #333335;
    border-radius: 60rpx 60rpx 60rpx 60rpx;
    margin: 48rpx 0;

    font-weight: 500;
    font-size: 32rpx;
    color: #FFFFFF;
    text-align: center;
  }

  .text {
    margin-top: 12rpx;
    font-weight: 400;
    font-size: 28rpx;
    color: #86909C;
    text-align: right;

  }

  .u-input {}
}
.sett-box {
  background: #ffffff;
  width: 100%;
  min-height: 100vh;
  line-height: 1;
  position: relative;

  .sendTag {
    margin-top: 25rpx;
    font-weight: 400;
    font-size: 28rpx;
    color: #86909C;
    text-align: left;

  }

  //padding: 36rpx 40rpx;
  .greeting-area1 {
    height: 438rpx;
  }

  .greeting-area {
    background-image: url('/static/login/loginBg.png');
    background-size: 100%;
    background-repeat: no-repeat;
    padding-left: 64rpx;
    padding-top: 256rpx;

    top: 0;
    z-index: 4;
    height: 438rpx;
    position: absolute;
    overflow: hidden;
    width: 100%;

    .bubble-text {
      font-weight: 500;
      font-size: 52rpx;
      color: #1D2129
    }

  }

  .code-btn {
    font-weight: 400;
    font-size: 30rpx;
    color: #19D29B;
    text-align: center;
    font-style: normal;
    text-transform: none;
  }


}

.input-box {
  width: 622rpx;
  height: 110rpx;
  background: #FFFFFF;
  display: flex;
  align-items: center;
  border-bottom: 1rpx solid #E7E7E7;

  .label {
    display: flex;
  }

  .input-item {
    flex: 1;
  }

  ::v-deep .uni-input-input {
    font-weight: 500;
    font-size: 30rpx;
    color: #1D2129;
  }
}
</style>
